

import java.io.* ;

public class PortInputStream extends InputStream {
  Port P ;
  ByteArrayInputStream strm ;
  int count ;

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
  //                                                                     //
  // Constructor.                                                        //
  //                                                                     //
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

  public PortInputStream(Port P) {
    this.P = P ;
    count = 0 ;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
  //                                                                     //
  // Methods.                                                            //
  //                                                                     //
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

  public synchronized int read() {

    if(count == 0) {
      byte data [] = P.recv() ;
      count = data.length ;
      while(count == 0) {
	data = P.recv() ;
	count = data.length ;
      }
      strm = new ByteArrayInputStream(data) ;
    }

    count-- ;
    return strm.read() ;
  }

  public synchronized int read(byte b [], int off, int len) {

    if(len > 0) {
      if(count == 0) {
        byte data [] = P.recv() ;
        count = data.length ;
        while(count == 0) {
	  data = P.recv() ;
	  count = data.length ;
        }
        strm = new ByteArrayInputStream(data) ;
      }

      int nbytes = strm.read(b, off, len) ;
      count -= nbytes ;
      return nbytes ;
    }
    else
      return 0 ;
  }

  public synchronized int available() {return count ; }
}

